## kodi 19.4+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4)
if(WIN32)
  # Version 3.15 is required to use "PREPEND" for dependencies
  cmake_minimum_required(VERSION 3.15)
endif()
project(kodi LANGUAGES CXX C ASM)

if(POLICY CMP0069)
  set(CMAKE_POLICY_DEFAULT_CMP0069 NEW)
  cmake_policy(SET CMP0069 NEW)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)
if(DEPENDS_DIR)
  list(APPEND CMAKE_PREFIX_PATH ${DEPENDS_DIR})
endif()

# Set CORE_BUILD_DIR
set(CORE_BUILD_DIR build)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

message(STATUS "Source directory: ${CMAKE_SOURCE_DIR}")
message(STATUS "Build directory: ${CMAKE_BINARY_DIR}")
if(CMAKE_BINARY_DIR STREQUAL CMAKE_SOURCE_DIR)
  message(WARNING "In-source build detected. It is recommended to build out-of-source.")
endif()

# Hide messages from Check*.cmake (e.g. CheckCSourceCompiles)
if(NOT VERBOSE)
  set(CMAKE_REQUIRED_QUIET ON)
endif()

# Includes
include(cmake/modules/extra/ECMEnableSanitizers.cmake)
include(cmake/scripts/common/GeneratorSetup.cmake)
include(cmake/scripts/common/AddOptions.cmake)
include(cmake/scripts/common/Platform.cmake)
include(cmake/scripts/common/ArchSetup.cmake)
include(cmake/scripts/common/Macros.cmake)
include(cmake/scripts/common/ProjectMacros.cmake)
core_find_versions()
include(cmake/scripts/${CORE_SYSTEM_NAME}/PathSetup.cmake)
include(cmake/scripts/common/CompilerSettings.cmake)
include(ExternalProject)


# general
option(VERBOSE            "Enable verbose output?" OFF)
option(ENABLE_CLANGTIDY   "Enable clang-tidy support?" OFF)
option(ENABLE_CPPCHECK    "Enable cppcheck support?" OFF)
option(ENABLE_DVDCSS      "Enable libdvdcss support?" ON)
option(ENABLE_INCLUDEWHATYOUUSE "Enable include-what-you-use support?" OFF)
option(ENABLE_UPNP        "Enable UPnP support?" ON)
option(ENABLE_AIRTUNES    "Enable AirTunes support?" ON)
option(ENABLE_OPTICAL     "Enable optical support?" ON)
option(ENABLE_PYTHON      "Enable python support?" ON)
option(ENABLE_TESTING     "Enable testing support?" ON)
# use ffmpeg from depends or system
option(ENABLE_INTERNAL_FFMPEG "Enable internal ffmpeg?" OFF)
if(UNIX)
  option(FFMPEG_PATH        "Path to external ffmpeg?" "")
  option(ENABLE_INTERNAL_CROSSGUID "Enable internal crossguid?" ON)
  option(ENABLE_INTERNAL_RapidJSON "Enable internal rapidjson?" OFF)
  option(ENABLE_INTERNAL_FMT "Enable internal fmt?" OFF)
  option(ENABLE_INTERNAL_FSTRCMP "Enable internal fstrcmp?" OFF)
  option(ENABLE_INTERNAL_FLATBUFFERS "Enable internal flatbuffers?" OFF)
  option(ENABLE_INTERNAL_DAV1D "Enable internal dav1d?" OFF)
  option(ENABLE_INTERNAL_GTEST "Enable internal gtest?" OFF)
  option(ENABLE_INTERNAL_UDFREAD "Enable internal udfread?" OFF)
  option(ENABLE_INTERNAL_SPDLOG "Enable internal spdlog?" OFF)
endif()
# prefer kissfft from xbmc/contrib but let use system one on unices
include(CMakeDependentOption)
cmake_dependent_option(ENABLE_INTERNAL_KISSFFT "Enable internal kissfft?" ON "UNIX" ON)
# System options
if(NOT WIN32)
  option(WITH_ARCH              "build with given arch" OFF)
  option(WITH_CPU               "build with given cpu" OFF)
endif()
if(CORE_SYSTEM_NAME STREQUAL linux)
  option(ENABLE_EVENTCLIENTS    "Enable event clients support?" OFF)
endif()

# Build static libraries per directory
if(NOT CMAKE_GENERATOR MATCHES "Visual Studio" AND NOT CMAKE_GENERATOR STREQUAL Xcode)
  set(ENABLE_STATIC_LIBS TRUE)
else()
  set(ENABLE_STATIC_LIBS FALSE)
endif()

core_find_git_rev(APP_SCMID FULL)

# Dynamically loaded libraries built with the project
add_custom_target(${APP_NAME_LC}-libraries)
set(LIBRARY_FILES "" CACHE STRING "" FORCE)
mark_as_advanced(LIBRARY_FILES)

set(INCLUDES ${CMAKE_SOURCE_DIR}
             ${CMAKE_SOURCE_DIR}/lib
             ${CMAKE_SOURCE_DIR}/xbmc
             ${CMAKE_SOURCE_DIR}/xbmc/${PLATFORM_DIR}
             ${CMAKE_SOURCE_DIR}/xbmc/cores/VideoPlayer
             ${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}
             ${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}/include)

if (NOT PLATFORMDEFS_DIR STREQUAL "")
  list(APPEND INCLUDES ${CMAKE_SOURCE_DIR}/xbmc/${PLATFORMDEFS_DIR})
endif()

find_package(PkgConfig)
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads REQUIRED QUIET)
list(APPEND DEPLIBS ${CMAKE_THREAD_LIBS_INIT})


foreach(depspec ${PLATFORM_REQUIRED_DEPS})
  # We need to specify ENABLE_${PLATFORM_REQUIRED_DEPS} in order for the
  # optional subdirectory for the specified platform to get built.
  split_dependency_specification(${depspec} dep version)
  string(TOUPPER ${dep} depup)
  if(NOT ${ENABLE_${depup}} STREQUAL AUTO AND NOT ${ENABLE_${depup}})
    message(WARNING "Your request to disable the dependency ${dep} required on platform ${CORE_PLATFORM_NAME} was ignored. Please choose another platform or add \"-DENABLE_${depup}=ON\" to your CMake command line to resolve this warning.")
  endif()
  set(ENABLE_${depup} "ON" CACHE BOOL "Force enabling required ${depup} support" FORCE)
endforeach()

# Required dependencies. Keep in alphabetical order please
set(required_deps ASS
                  Cdio
                  CrossGUID
                  Curl
                  FFMPEG
                  FlatBuffers
                  Fmt
                  FreeType
                  FriBidi
                  fstrcmp
                  Iconv
                  KissFFT
                  LibDvd
                  Lzo2
                  OpenSSL>=1.0.2
                  PCRE
                  RapidJSON
                  Spdlog
                  Sqlite3
                  TagLib
                  TinyXML
                  ZLIB
                  ${PLATFORM_REQUIRED_DEPS})

# Optional dependencies. Keep in alphabetical order please
set(optional_deps Alsa
                  Avahi
                  Bluetooth
                  Bluray
                  CAP
                  CCache
                  CEC
                  ClangFormat
                  ClangTidy
                  Cppcheck
                  Dav1d
                  DBus
                  IncludeWhatYouUse
                  Iso9660pp
                  LCMS2
                  LircClient
                  MDNS
                  MicroHttpd
                  NFS
                  Plist
                  PulseAudio
                  Python
                  SmbClient
                  Sndio
                  UDEV
                  Udfread
                  XSLT
                  ${PLATFORM_OPTIONAL_DEPS})

# Check optional deps first, since their availability can influence required ones, e.g. ffmpeg
core_optional_dep(${optional_deps})
core_require_dep(${required_deps})

# Required tools
find_package(TexturePacker REQUIRED)
find_package(JsonSchemaBuilder REQUIRED)

SET(PYTHON_VERSION 3.8)

if(ENABLE_MARIADBCLIENT AND NOT ENABLE_MARIADBCLIENT STREQUAL AUTO AND ENABLE_MYSQLCLIENT AND NOT ENABLE_MYSQLCLIENT STREQUAL AUTO)
  MESSAGE(FATAL_ERROR "You can not use MySql and MariaDB at the same time. Disable one by adding -DENABLE_MYSQLCLIENT=OFF or -DENABLE_MARIADBCLIENT=OFF.")
elseif(ENABLE_MYSQLCLIENT AND NOT ENABLE_MYSQLCLIENT STREQUAL AUTO)
  set(ENABLE_MARIADBCLIENT OFF CACHE BOOL "")
endif()

core_optional_dep(MariaDBClient)
if(NOT MARIADBCLIENT_FOUND)
  core_optional_dep(MySqlClient)
endif()

if(NOT UDEV_FOUND)
  core_optional_dep(LibUSB)
endif()

if(ENABLE_UPNP)
  list(APPEND DEP_DEFINES "-DHAS_UPNP=1")
endif()

if(ENABLE_OPTICAL)
  list(APPEND DEP_DEFINES -DHAS_DVD_DRIVE -DHAS_CDDA_RIPPER)
endif()

if(ENABLE_AIRTUNES)
  find_package(Shairplay)
  if(SHAIRPLAY_FOUND)
    core_require_dep(Shairplay)
  endif()
endif()

if(CORE_SYSTEM_NAME STREQUAL osx)
  core_require_dep(Sdl)
endif()

# find all folders containing addon.xml.in
# used to define ADDON_XML_OUTPUTS, ADDON_XML_DEPENDS and ADDON_INSTALL_DATA
# Function defined in ./cmake/scripts/common/Macros.cmake
set(outputFilterRegex "addons/xbmc.json")
find_addon_xml_in_files(${outputFilterRegex})

# Compile Info
add_custom_command(OUTPUT ${CORE_BUILD_DIR}/xbmc/CompileInfo.cpp
                          ${ADDON_XML_OUTPUTS}
                   COMMAND ${CMAKE_COMMAND} -DCORE_SOURCE_DIR=${CMAKE_SOURCE_DIR}
                                            -DCORE_SYSTEM_NAME=${CORE_SYSTEM_NAME}
                                            -DCORE_PLATFORM_NAME_LC="${CORE_PLATFORM_NAME_LC}"
                                            -DCORE_BUILD_DIR=${CORE_BUILD_DIR}
                                            -DCMAKE_BINARY_DIR=${CMAKE_BINARY_DIR}
                                            -DARCH_DEFINES="${ARCH_DEFINES}"
                                            -DAPP_SCMID=${APP_SCMID}
                                            -DAPP_COPYRIGHT_YEARS=${APP_COPYRIGHT_YEARS}
                                            -DAPP_BUILD_DATE=${APP_BUILD_DATE}
                                            -DAPP_SHARED_LIBRARY_SUFFIX="${APP_SHARED_LIBRARY_SUFFIX}"
                                            -Dprefix=${CMAKE_BINARY_DIR}/${CORE_BUILD_DIR}
                                            -P ${CMAKE_SOURCE_DIR}/cmake/scripts/common/GenerateVersionedFiles.cmake
                   DEPENDS ${CMAKE_SOURCE_DIR}/version.txt
                           export-files
                           ${ADDON_XML_DEPENDS}
                           ${CMAKE_SOURCE_DIR}/xbmc/CompileInfo.cpp.in)
list(APPEND install_data ${ADDON_INSTALL_DATA})
add_library(compileinfo OBJECT ${CORE_BUILD_DIR}/xbmc/CompileInfo.cpp)
set_target_properties(compileinfo PROPERTIES FOLDER "Build Utilities")
target_compile_options(compileinfo PRIVATE "${SYSTEM_DEFINES} ${ARCH_DEFINES}")
add_dependencies(compileinfo fmt)

# RC File
if(WIN32)
  configure_file(${CMAKE_SOURCE_DIR}/xbmc/platform/win32/XBMC_PC.rc.in
                 ${CORE_BUILD_DIR}/xbmc/platform/win32/XBMC_PC.rc @ONLY)
  add_library(resources OBJECT ${CORE_BUILD_DIR}/xbmc/platform/win32/XBMC_PC.rc)
  set_target_properties(resources PROPERTIES FOLDER "Build Utilities")
  target_include_directories(resources PRIVATE ${CMAKE_SOURCE_DIR}/tools/windows/packaging/media)
  set(RESOURCES $<TARGET_OBJECTS:resources>)
endif()

# Generate messages
core_add_subdirs_from_filelist(${CMAKE_SOURCE_DIR}/cmake/messages/flatbuffers/*.txt)

include_directories(${INCLUDES} ${SYSTEM_INCLUDES})
add_compile_options(${ARCH_DEFINES} "${SYSTEM_DEFINES}" ${DEP_DEFINES} ${PATH_DEFINES})

set(core_DEPENDS "" CACHE STRING "" FORCE)
set(test_archives "" CACHE STRING "" FORCE)
set(test_sources "" CACHE STRING "" FORCE)
set(sca_sources "" CACHE STRING "" FORCE)
mark_as_advanced(core_DEPENDS)
mark_as_advanced(test_archives)
mark_as_advanced(test_sources)

# copy files to build tree
copy_files_from_filelist_to_buildtree(${CMAKE_SOURCE_DIR}/cmake/installdata/common/*.txt
                                      ${CMAKE_SOURCE_DIR}/cmake/installdata/${CORE_SYSTEM_NAME}/*.txt)

list(APPEND SKINS "${CMAKE_SOURCE_DIR}/addons/skin.estuary\;${CMAKE_SOURCE_DIR}")
list(APPEND SKINS "${CMAKE_SOURCE_DIR}/addons/skin.estouchy\;${CMAKE_SOURCE_DIR}")

# These are skins that are copied into place from the source tree
foreach(skin ${SKINS})
  list(GET skin 0 dir)
  list(GET skin 1 relative)
  copy_skin_to_buildtree(${dir} ${relative})
endforeach()

add_custom_target(pack-skins ALL
                  DEPENDS TexturePacker::TexturePacker::Executable export-files ${XBT_FILES})
set_target_properties(pack-skins PROPERTIES FOLDER "Build Utilities")

file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/system/players/VideoPlayer)

set(LIBCEC_SONAME "${CEC_SONAME}")
if(NOT CORE_SYSTEM_NAME STREQUAL windows AND NOT CORE_SYSTEM_NAME STREQUAL android AND NOT CORE_SYSTEM_NAME STREQUAL windowsstore)
  configure_file(${CMAKE_SOURCE_DIR}/xbmc/DllPaths_generated.h.in
                 ${CORE_BUILD_DIR}/DllPaths_generated.h @ONLY)
elseif(CORE_SYSTEM_NAME STREQUAL android)
  configure_file(${CMAKE_SOURCE_DIR}/xbmc/DllPaths_generated_android.h.in
                 ${CORE_BUILD_DIR}/DllPaths_generated_android.h @ONLY)
endif()

set(GLOBAL_TARGET_DEPS ffmpeg dvdnav crossguid fmt Spdlog::Spdlog fstrcmp flatbuffers ${PLATFORM_GLOBAL_TARGET_DEPS})

=== xbmc/addons/CMakeLists.txt ===
set(SOURCES Addon.cpp
            AddonBuilder.cpp
            BinaryAddonCache.cpp
            AddonDatabase.cpp
            AddonInstaller.cpp
            AddonManager.cpp
            AddonRepos.cpp
            AddonStatusHandler.cpp
            AddonSystemSettings.cpp
            AddonUpdateRules.cpp
            AddonVersion.cpp
            AudioDecoder.cpp
            AudioEncoder.cpp
            ContextMenuAddon.cpp
            ContextMenus.cpp
            FontResource.cpp
            FilesystemInstaller.cpp
            GameResource.cpp
            ImageDecoder.cpp
            ImageResource.cpp
            LanguageResource.cpp
            PluginSource.cpp
            Repository.cpp
            RepositoryUpdater.cpp
            Scraper.cpp
            ScreenSaver.cpp
            Service.cpp
            Skin.cpp
            UISoundsResource.cpp
            VFSEntry.cpp
            Visualization.cpp
            Webinterface.cpp)

set(HEADERS Addon.h
            AddonBuilder.h
            AddonEvents.h
            AddonRepoInfo.h
            BinaryAddonCache.h
            AddonDatabase.h
            AddonInstaller.h
            AddonManager.h
            AddonProvider.h
            AddonRepos.h
            AddonStatusHandler.h
            AddonSystemSettings.h
            AddonUpdateRules.h
            AddonVersion.h
            AudioDecoder.h
            AudioEncoder.h
            ContextMenuAddon.h
            ContextMenus.h
            FilesystemInstaller.h
            FontResource.h
            GameResource.h
            IAddon.h
            ImageDecoder.h
            ImageResource.h
            LanguageResource.h
            PluginSource.h
            Repository.h
            RepositoryUpdater.h
            Resource.h
            Scraper.h
            ScreenSaver.h
            Service.h
            Skin.h
            UISoundsResource.h
            VFSEntry.h
            Visualization.h
            Webinterface.h)

core_add_library(addons)

=== xbmc/favourites/CMakeLists.txt ===
set(SOURCES ContextMenus.cpp
            GUIDialogFavourites.cpp
            FavouritesService.cpp)

set(HEADERS ContextMenus.h
            GUIDialogFavourites.h
            FavouritesService)

core_add_library(favourites)

=== xbmc/input/CMakeLists.txt ===
set(SOURCES AppTranslator.cpp
            ButtonTranslator.cpp
            CustomControllerTranslator.cpp
            GamepadTranslator.cpp
            InertialScrollingHandler.cpp
            InputCodingTableBasePY.cpp
            InputCodingTableFactory.cpp
            InputCodingTableKorean.cpp
            InputManager.cpp
            InputTranslator.cpp
            IRTranslator.cpp
            JoystickMapper.cpp
            Key.cpp
            KeyboardLayout.cpp
            KeyboardLayoutManager.cpp
            KeyboardStat.cpp
            KeyboardTranslator.cpp
            Keymap.cpp
            KeymapEnvironment.cpp
            TouchTranslator.cpp
            WindowKeymap.cpp
            WindowTranslator.cpp
            XBMC_keytable.cpp)

set(HEADERS hardware/IHardwareInput.h
            remote/IRRemote.h
            AppTranslator.h
            ButtonTranslator.h
            CustomControllerTranslator.h
            GamepadTranslator.h
            IButtonMapper.h
            IKeymap.h
            IKeymapEnvironment.h
            InertialScrollingHandler.h
            InputCodingTable.h
            InputCodingTableBasePY.h
            InputCodingTableFactory.h
            InputCodingTableKorean.h
            InputManager.h
            InputTranslator.h
            InputTypes.h
            IRTranslator.h
            JoystickMapper.h
            Key.h
            KeyboardLayout.h
            KeyboardLayoutManager.h
            KeyboardStat.h
            KeyboardTranslator.h
            Keymap.h
            KeymapEnvironment.h
            TouchTranslator.h
            WindowTranslator.h
            WindowKeymap.h
            XBMC_keyboard.h
            XBMC_keysym.h
            XBMC_keytable.h
            XBMC_vkeys.h)

core_add_library(input)

=== xbmc/listproviders/CMakeLists.txt ===
set(SOURCES DirectoryProvider.cpp
            IListProvider.cpp
            MultiProvider.cpp
            StaticProvider.cpp)

set(HEADERS DirectoryProvider.h
            IListProvider.h
            MultiProvider.h
            StaticProvider.h)

core_add_library(listproviders)

=== xbmc/network/CMakeLists.txt ===
set(SOURCES DNSNameCache.cpp
            EventClient.cpp
            EventPacket.cpp
            EventServer.cpp
            GUIDialogNetworkSetup.cpp
            Network.cpp
            NetworkServices.cpp
            Socket.cpp
            TCPServer.cpp
            UdpClient.cpp
            WakeOnAccess.cpp
            ZeroconfBrowser.cpp
            Zeroconf.cpp)

set(HEADERS DNSNameCache.h
            EventClient.h
            EventPacket.h
            EventServer.h
            GUIDialogNetworkSetup.h
            Network.h
            NetworkServices.h
            Socket.h
            TCPServer.h
            UdpClient.h
            WakeOnAccess.h
            Zeroconf.h
            ZeroconfBrowser.h)

if(ENABLE_OPTICAL)
  list(APPEND SOURCES cddb.cpp)
  list(APPEND HEADERS cddb.h)
endif()

if(PLIST_FOUND)
  list(APPEND SOURCES AirPlayServer.cpp)
  list(APPEND HEADERS AirPlayServer.h)
endif()

if(SHAIRPLAY_FOUND)
  list(APPEND SOURCES AirTunesServer.cpp)
  list(APPEND HEADERS AirTunesServer.h)
endif()

if(MICROHTTPD_FOUND)
  list(APPEND SOURCES WebServer.cpp)
  list(APPEND HEADERS WebServer.h)
endif()

core_add_library(network)
if(BLUETOOTH_FOUND)
  target_compile_definitions(${CORE_LIBRARY} PRIVATE -DHAVE_LIBBLUETOOTH=1)
endif()

if(ENABLE_UPNP)
  target_include_directories(${CORE_LIBRARY} PRIVATE ${CMAKE_SOURCE_DIR}/lib/libUPnP
                                                     ${CMAKE_SOURCE_DIR}/lib/libUPnP/Platinum/Source/Core
                                                     ${CMAKE_SOURCE_DIR}/lib/libUPnP/Platinum/Source/Platinum
                                                     ${CMAKE_SOURCE_DIR}/lib/libUPnP/Platinum/Source/Devices/MediaConnect
                                                     ${CMAKE_SOURCE_DIR}/lib/libUPnP/Platinum/Source/Devices/MediaRenderer
                                                     ${CMAKE_SOURCE_DIR}/lib/libUPnP/Platinum/Source/Devices/MediaServer
                                                     ${CMAKE_SOURCE_DIR}/lib/libUPnP/Neptune/Source/System/Posix
                                                     ${CMAKE_SOURCE_DIR}/lib/libUPnP/Neptune/Source/Core)
endif()

=== xbmc/settings/CMakeLists.txt ===
set(SOURCES AdvancedSettings.cpp
            DisplaySettings.cpp
            GameSettings.cpp
            LibExportSettings.cpp
            MediaSettings.cpp
            MediaSourceSettings.cpp
            SettingAddon.cpp
            SettingConditions.cpp
            SettingControl.cpp
            SettingCreator.cpp
            SettingDateTime.cpp
            SettingPath.cpp
            Settings.cpp
            SettingsBase.cpp
            SettingsValueFlatJsonSerializer.cpp
            SettingsValueXmlSerializer.cpp
            SettingUtils.cpp
            SkinSettings.cpp
            SettingsComponent.cpp)

set(HEADERS AdvancedSettings.h
            DiscSettings.h
            DisplaySettings.h
            GameSettings.h
            ISubSettings.h
            LibExportSettings.h
            MediaSettings.h
            MediaSourceSettings.h
            SettingAddon.h
            SettingConditions.h
            SettingControl.h
            SettingCreator.h
            SettingDateTime.h
            SettingPath.h
            Settings.h
            SettingsBase.h
            SettingsValueFlatJsonSerializer.h
            SettingsValueXmlSerializer.h
            SettingUtils.h
            SkinSettings.h
            SettingsComponent.h)

if(BLURAY_FOUND)
  list(APPEND SOURCES DiscSettings.cpp)
endif()

core_add_library(settings)

=== xbmc/storage/CMakeLists.txt ===
set(SOURCES AutorunMediaJob.cpp
            MediaManager.cpp)

set(HEADERS AutorunMediaJob.h
            IStorageProvider.h
            MediaManager.h)

if(ENABLE_OPTICAL)
  list(APPEND SOURCES cdioSupport.cpp
                      DetectDVDType.cpp)
  list(APPEND HEADERS cdioSupport.h
                      DetectDVDType.h)
endif()

core_add_library(storage)

=== xbmc/video/CMakeLists.txt ===
set(SOURCES Bookmark.cpp
            ContextMenus.cpp
            GUIViewStateVideo.cpp
            PlayerController.cpp
            Teletext.cpp
            VideoDatabase.cpp
            VideoDbUrl.cpp
            VideoInfoDownloader.cpp
            VideoInfoScanner.cpp
            VideoInfoTag.cpp
            VideoLibraryQueue.cpp
            VideoThumbLoader.cpp
            ViewModeSettings.cpp)

set(HEADERS Bookmark.h
            ContextMenus.h
            Episode.h
            GUIViewStateVideo.h
            PlayerController.h
            Teletext.h
            TeletextDefines.h
            VideoDatabase.h
            VideoDbUrl.h
            VideoInfoDownloader.h
            VideoInfoScanner.h
            VideoInfoTag.h
            VideoLibraryQueue.h
            VideoThumbLoader.h
            ViewModeSettings.h)

core_add_library(video)

=== xbmc/windowing/CMakeLists.txt ===
set(SOURCES GraphicContext.cpp
            OSScreenSaver.cpp
            Resolution.cpp
            WindowSystemFactory.cpp
            WinSystem.cpp)

set(HEADERS GraphicContext.h
            OSScreenSaver.h
            Resolution.h
            WinEvents.h
            WindowSystemFactory.h
            WinSystem.h
            XBMC_events.h
            VideoSync.h)

core_add_library(windowing)

=== xbmc/addons/kodi-dev-kit/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(kodi-dev-kit)

include(cmake/test/abi-interface-test.cmake)

=== xbmc/cores/AudioEngine/CMakeLists.txt ===
set(SOURCES AEResampleFactory.cpp
            AESinkFactory.cpp
            Encoders/AEEncoderFFmpeg.cpp
            Engines/ActiveAE/ActiveAE.cpp
            Engines/ActiveAE/ActiveAEBuffer.cpp
            Engines/ActiveAE/ActiveAEFilter.cpp
            Engines/ActiveAE/ActiveAESink.cpp
            Engines/ActiveAE/ActiveAEStream.cpp
            Engines/ActiveAE/ActiveAESound.cpp
            Engines/ActiveAE/ActiveAESettings.cpp
            Utils/AEBitstreamPacker.cpp
            Utils/AEChannelInfo.cpp
            Utils/AEDeviceInfo.cpp
            Utils/AELimiter.cpp
            Utils/AEPackIEC61937.cpp
            Utils/AEStreamInfo.cpp
            Utils/AEUtil.cpp)

set(HEADERS AEResampleFactory.h
            AESinkFactory.h
            Encoders/AEEncoderFFmpeg.h
            Engines/ActiveAE/ActiveAE.h
            Engines/ActiveAE/ActiveAEBuffer.h
            Engines/ActiveAE/ActiveAEFilter.h
            Engines/ActiveAE/ActiveAESink.h
            Engines/ActiveAE/ActiveAESound.h
            Engines/ActiveAE/ActiveAEStream.h
            Engines/ActiveAE/ActiveAESettings.h
            Interfaces/AE.h
            Interfaces/AEEncoder.h
            Interfaces/AEResample.h
            Interfaces/AESink.h
            Interfaces/AESound.h
            Interfaces/AEStream.h
            Interfaces/IAudioCallback.h
            Interfaces/ThreadedAE.h
            Utils/AEAudioFormat.h
            Utils/AEBitstreamPacker.h
            Utils/AEChannelData.h
            Utils/AEChannelInfo.h
            Utils/AEDeviceInfo.h
            Utils/AELimiter.h
            Utils/AEPackIEC61937.h
            Utils/AERingBuffer.h
            Utils/AEStreamData.h
            Utils/AEStreamInfo.h
            Utils/AEUtil.h)

if(ALSA_FOUND)
  list(APPEND SOURCES Sinks/AESinkALSA.cpp
                      Utils/AEELDParser.cpp)
  list(APPEND HEADERS Sinks/AESinkALSA.h
                      Utils/AEELDParser.h)

  if(NOT "x11" IN_LIST CORE_PLATFORM_NAME_LC)
    list(APPEND SOURCES Sinks/alsa/ALSAHControlMonitor.cpp)
    list(APPEND HEADERS Sinks/alsa/ALSAHControlMonitor.h)
  endif()

  if(UDEV_FOUND)
    list(APPEND SOURCES Sinks/alsa/ALSADeviceMonitor.cpp)
    list(APPEND HEADERS Sinks/alsa/ALSADeviceMonitor.h)
  endif()
endif()

if(PULSEAUDIO_FOUND)
  list(APPEND SOURCES Sinks/AESinkPULSE.cpp)
  list(APPEND HEADERS Sinks/AESinkPULSE.h)
endif()

if(SNDIO_FOUND)
  list(APPEND SOURCES Sinks/AESinkSNDIO.cpp)
  list(APPEND HEADERS Sinks/AESinkSNDIO.h)
endif()

if(FFMPEG_FOUND)
  list(APPEND SOURCES Engines/ActiveAE/ActiveAEResampleFFMPEG.cpp)
  list(APPEND HEADERS Engines/ActiveAE/ActiveAEResampleFFMPEG.h)
endif()

if(CORE_SYSTEM_NAME MATCHES windows)
  list(APPEND SOURCES Sinks/AESinkWASAPI.cpp
                      Sinks/windows/AESinkFactoryWin.cpp)
  list(APPEND HEADERS Sinks/AESinkWASAPI.h
                      Sinks/windows/AESinkFactoryWin.h)
  if(CORE_SYSTEM_NAME STREQUAL windowsstore)
    list(APPEND SOURCES Sinks/AESinkXAudio.cpp
                        Sinks/windows/AESinkFactoryWin10.cpp)
    list(APPEND SOURCES Sinks/AESinkXAudio.h)
  elseif(CORE_SYSTEM_NAME STREQUAL windows)
    list(APPEND SOURCES Sinks/AESinkDirectSound.cpp
                        Sinks/windows/AESinkFactoryWin32.cpp)
    list(APPEND SOURCES Sinks/AESinkDirectSound.h)
  endif()
endif()

if(CORE_SYSTEM_NAME STREQUAL osx)
  list(APPEND SOURCES Sinks/AESinkDARWINOSX.cpp
                      Sinks/darwin/CoreAudioHelpers.cpp
                      Sinks/osx/AEDeviceEnumerationOSX.cpp
                      Sinks/osx/CoreAudioChannelLayout.cpp
                      Sinks/osx/CoreAudioDevice.cpp
                      Sinks/osx/CoreAudioHardware.cpp
                      Sinks/osx/CoreAudioStream.cpp)
  list(APPEND HEADERS Sinks/AESinkDARWINOSX.h
                      Sinks/darwin/CoreAudioHelpers.h
                      Sinks/osx/AEDeviceEnumerationOSX.h
                      Sinks/osx/CoreAudioChannelLayout.h
                      Sinks/osx/CoreAudioDevice.h
                      Sinks/osx/CoreAudioHardware.h
                      Sinks/osx/CoreAudioStream.h)
endif()

if(CORE_SYSTEM_NAME STREQUAL darwin_embedded)
  list(APPEND SOURCES Sinks/darwin/CoreAudioHelpers.cpp)
  list(APPEND HEADERS Sinks/darwin/CoreAudioHelpers.h)
  if("ios" IN_LIST CORE_PLATFORM_NAME_LC)
    list(APPEND SOURCES Sinks/AESinkDARWINIOS.mm)
    list(APPEND HEADERS Sinks/AESinkDARWINIOS.h)
  elseif("tvos" IN_LIST CORE_PLATFORM_NAME_LC)
    list(APPEND SOURCES Sinks/AESinkDARWINTVOS.mm)
    list(APPEND HEADERS Sinks/AESinkDARWINTVOS.h)
  endif()
endif()

if(CORE_SYSTEM_NAME STREQUAL android)
  list(APPEND SOURCES Sinks/AESinkAUDIOTRACK.cpp)
  list(APPEND HEADERS Sinks/AESinkAUDIOTRACK.h)
endif()

if(CORE_SYSTEM_NAME STREQUAL freebsd)
  list(APPEND SOURCES Sinks/AESinkOSS.cpp)
  list(APPEND HEADERS Sinks/AESinkOSS.h)
endif()

core_add_library(audioengine)
target_include_directories(${CORE_LIBRARY} PRIVATE ${CMAKE_CURRENT_SOURCE_DIR})
if(NOT CORE_SYSTEM_NAME STREQUAL windows AND NOT CORE_SYSTEM_NAME STREQUAL windowsstore)
  if(HAVE_SSE)
    target_compile_options(${CORE_LIBRARY} PRIVATE -msse)
  endif()
  if(HAVE_SSE2)
    target_compile_options(${CORE_LIBRARY} PRIVATE -msse2)
  endif()
endif()

=== debian/control ===
Source: kodi
Priority: optional
Section: video
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders: Vasyl Gello <vasek.gello@gmail.com>
Build-Depends: autoconf,
               automake,
               autopoint,
               cmake,
               curl,
               debhelper-compat (= 13),
               default-jre:native,
               default-libmysqlclient-dev,
               dh-python,
               doxygen,
               fontforge-nox,
               fonts-dejavu-core,
               fonts-droid-fallback,
               gawk,
               gettext,
               gperf,
               groovy:native,
               libasound2-dev | libasound-dev,
               libass-dev,
               libavahi-client-dev,
               libavahi-common-dev,
               libavcodec-dev (>= 7:4.2.2),
               libavfilter-dev (>= 7:4.2.2),
               libavformat-dev (>= 7:4.2.2),
               libavutil-dev (>= 7:4.2.2),
               libbluetooth-dev,
               libbluray-dev (>= 1:0.7.0),
               libcap-dev,
               libcdio-dev,
               libcec-dev (>= 4~),
               libcommons-lang-java:native,
               libcrossguid-dev,
               libcurl4-gnutls-dev | libcurl-dev,
               libcwiid-dev [linux-any],
               libdav1d-dev (>= 0.7.0),
               libdbus-1-dev,
               libdrm-dev,
#               libdvdnav-dev, use patched embedded version
#               libdvdread-dev, use patched embedded version
               libegl1-mesa-dev,
               libflatbuffers-dev,
               libfmt-dev (>= 6.1.2),
               libfontconfig-dev,
               libfreetype-dev | libfreetype6-dev,
               libfribidi-dev,
               libfstrcmp-dev,
               libgbm-dev,
               libgcrypt-dev,
               libgif-dev,
               libgif-dev:native,
               libgl1-mesa-dev | libgl-dev,
               libglew-dev,
               libglu1-mesa-dev | libglu-dev,
               libgnutls28-dev,
               libgpg-error-dev,
               libgtest-dev (>= 1.10.0~),
               libinput-dev,
               libiso9660-dev,
               libiso9660++-dev,
               libjpeg-dev,
               libjpeg-dev:native,
               libkissfft-dev (>= 131.1.0~),
               liblcms2-dev,
               liblirc-dev | liblircclient-dev,
               libltdl-dev,
               liblzo2-dev,
               liblzo2-dev:native,
               libmicrohttpd-dev,
               libnfs-dev,
               libomxil-bellagio-dev [armel],
               libpcre3-dev,
               libplist-dev,
               libpng-dev,
               libpng-dev:native,
               libpostproc-dev (>= 7:4.2.2),
               libpulse-dev,
               libpython3-dev,
               librsvg2-bin,
               libshairplay-dev (>= 0.9.0~),
               libsmbclient-dev,
               libsndio-dev,
               libspdlog-dev (>= 1:1.5.0),
               libsqlite3-dev,
               libswresample-dev (>= 7:4.2.2),
               libswscale-dev (>= 7:4.2.2),
               libtag1-dev (>= 1.8),
               libtinyxml-dev,
               libtool,
               libudev-dev,
               libudfread-dev (>= 1.0.0),
               libva-dev,
               libvdpau-dev,
               libxkbcommon-dev,
               libxrandr-dev,
               libxslt1-dev,
               libxt-dev,
               nasm [i386],
               python3-dev:any,
               rapidjson-dev,
               swig,
               unzip,
               uuid-dev,
               valgrind [amd64 i386],
               wayland-protocols,
               waylandpp-dev,
               zip,
               zlib1g-dev
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/multimedia-team/kodi-media-center/kodi
Vcs-Git: https://salsa.debian.org/multimedia-team/kodi-media-center/kodi.git
Homepage: https://kodi.tv/

Package: kodi
Architecture: any
Depends: kodi-bin (>= ${source:Version}),
         kodi-bin (<< ${source:Version}.1~),
         kodi-data (>= ${source:Version}),
         ${misc:Depends}
Recommends: kodi-repository-kodi | kodi-repository,
            kodi-visualization-spectrum
Breaks: xbmc (<< 2:13.2+dfsg1-5~), ${kodi:APIBREAKS}
Provides: ${kodi:APIPROVIDES}
Replaces: xbmc (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (executable binaries)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains the kodi binaries.

Package: kodi-data
Architecture: all
Multi-Arch: foreign
Depends: mesa-utils,
         x11-utils,
         libjs-jquery,
         libjs-iscroll,
         ${misc:Depends}
Recommends: fonts-noto-hinted,
            fonts-noto-mono,
            fonts-roboto-hinted,
            fonts-roboto-unhinted
Breaks: xbmc (<< 2:13.2+dfsg1-5~)
Replaces: xbmc (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (arch-independent data package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains all the architecture independent data needed to have a
 working Kodi.

Package: kodi-bin
Architecture: any
Depends: python3-pil,
         python3-pycryptodome,
         ${python3:Depends},
         ${dlopenlibs:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
Recommends: ${shlibs:Recommends},
            udisks2
Pre-Depends: ${misc:Pre-Depends}
Breaks: xbmc-bin (<< 2:13.2+dfsg1-5~)
Conflicts: libgl1-mesa-swx11
Replaces: xbmc-bin (<< 2:13.2+dfsg1-5~)
Description: Open Source Home Theatre (architecture-dependent files)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package contains the binaries needed to have a working Kodi.

Package: kodi-eventclients-common
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Open Source Home Theatre (Event Client Common package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package is the common package for Kodi Event Client.

Package: kodi-eventclients-python
Architecture: any
Depends: kodi-eventclients-common (= ${source:Version}),
         python3-bluez,
         ${python3:Depends},
         ${misc:Depends}
Breaks: kodi-eventclients-common (<< 2:19.4+dfsg1-1~)
Replaces: kodi-eventclients-common (<< 2:19.4+dfsg1-1~)
Description: Open Source Home Theatre (Event Client Python package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital
 media. Kodi is available for Linux, Mac OS X (Leopard, Tiger and Apple TV)
 and Microsoft Windows, as well as the original Xbox game console. Created in
 2003 by a group of like minded programmers, Kodi is a non-profit project run
 and developed by volunteers located around the world. More than 50 software
 developers have contributed to Kodi, and 100-plus translators have worked to
 expand its reach, making it available in more than 30 languages.
 .
 While Kodi functions very well as a standard media player application for
 your computer, it has been designed to be the perfect companion for your
 HTPC. Supporting an almost endless range of remote controls, and combined
 with its beautiful interface and powerful skinning engine, Kodi feels very
 natural to use from the couch and is the ideal solution for your home
 theater. Once installed, your computer will become a fully functional
 multimedia jukebox.
 .
 This package is the virtual Python package for Kodi Event Client.

Package: kodi-eventclients-dev-common
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}
Breaks: kodi-eventclients-dev (<< 2:19.4+dfsg1-1~)
Replaces: kodi-eventclients-dev (<< 2:19.4+dfsg1-1~)
Description: Open Source Home Theatre (Event Client common dev package)
 Kodi, formerly known as XBMC is an award winning free and
 open source software media-player and entertainment hub for all your digital

=== debian/rules ===
#!/usr/bin/make -f

# Avoid custom build rule silencing
export V=1

# Include /usr/share/dpkg/pkg-info.mk to get DEB_{SOURCE,VERSION}
include /usr/share/dpkg/pkg-info.mk

# Include /usr/share/dpkg/architecture.mk to get DEB_HOST_{MULTI,}ARCH
include /usr/share/dpkg/architecture.mk

# bindnow breaks wrappers used in with libdvdread
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-bindnow

DATE_COMPONENT = libdate-tz-embedded
DATE_URL = tools/depends/target/date/libdate-tz-$$(grep VERSION tools/depends/target/date/DATE-VERSION | sed 's/^[^=]*=//').tar.xz
DVDNAV_COMPONENT = libdvdnav-embedded
DVDNAV_URL = tools/depends/target/libdvdnav/libdvdnav-$$(grep VERSION tools/depends/target/libdvdnav/DVDNAV-VERSION | sed 's/^[^=]*=//').tar.xz
DVDREAD_COMPONENT = libdvdread-embedded
DVDREAD_URL = tools/depends/target/libdvdread/libdvdread-$$(grep VERSION tools/depends/target/libdvdread/DVDREAD-VERSION | sed 's/^[^=]*=//').tar.xz

export DEB_CFLAGS_MAINT_STRIP  = -O2
export DEB_CFLAGS_MAINT_APPEND  = -O3
export DEB_CXXFLAGS_MAINT_STRIP  = -O2
export DEB_CXXFLAGS_MAINT_APPEND  = -O3

BUILD_WAYLAND := yes
BUILD_GBM := yes


NUMCPU =
# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NUMCPU := $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

# Various environment variables to set
export DEB_LDFLAGS_MAINT_APPEND = -latomic -lpthread
# for embedded libdvd*:
export DEB_CPPFLAGS_MAINT_APPEND = -D_XBMC

KODI_PLATFORMS := x11

ifeq ($(BUILD_WAYLAND),yes)
	KODI_PLATFORMS := $(KODI_PLATFORMS) wayland
endif
ifeq ($(BUILD_GBM),yes)
	KODI_PLATFORMS := $(KODI_PLATFORMS) gbm
endif

# basilgello: keep these overrides to ensure CMake honors
# the 32-bit architecture requested by 'dpkg-buildpackage'
# (like 'i486-linux') on 64-bit machines (like 'amd64').
ifneq (,$(filter amd64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=x86_64-linux
else ifneq (,$(filter armel armhf,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=arm
else ifneq (,$(filter i386,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=i486-linux
else ifneq (,$(filter mipsel,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=mips
else ifneq (,$(filter mips64el,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=mips64
else ifneq (,$(filter ppc64el,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=ppc64
else ifneq (,$(filter riscv64,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=riscv64
else ifneq (,$(filter s390x,$(DEB_HOST_ARCH)))
EXTRA_FLAGS := $(EXTRA_FLAGS) -DWITH_ARCH=s390x
endif

# basilgello: If cross-compiling, tell Kodi to look for native prerequisites
# in $(CURDIR)/native-tools, where the override_dh_autoconfigure step builds
# them for the build architecture (the native architecture of builder machine)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
EXTRA_FLAGS := $(EXTRA_FLAGS) \
	-DWITH_JSONSCHEMABUILDER=$(CURDIR)/native-tools/bin/JsonSchemaBuilder \
	-DWITH_TEXTUREPACKER=$(CURDIR)/native-tools/bin/TexturePacker
endif

KODI_OPTS=\
-DVERBOSE=1 \
-DUSE_LTO=$(NUMCPU) \
-DCMAKE_BUILD_TYPE=RelWithDebInfo \
-DENABLE_AIRTUNES=ON \
-DENABLE_ALSA=ON \
-DENABLE_AVAHI=ON \
-DENABLE_BLURAY=ON \
-DENABLE_CEC=ON \
-DENABLE_DBUS=ON \
-DENABLE_DEBUGFISSION=OFF \
-DENABLE_DVDCSS=OFF \
-DENABLE_EVENTCLIENTS=ON \
-DENABLE_INTERNAL_CROSSGUID=OFF \
-DENABLE_INTERNAL_FFMPEG=OFF \
-DENABLE_INTERNAL_KISSFFT=OFF \
-DENABLE_MICROHTTPD=ON \
-DENABLE_MYSQLCLIENT=ON \
-DENABLE_NFS=ON \
-DENABLE_OPTICAL=ON \
-DENABLE_PULSEAUDIO=ON \
-DENABLE_SMBCLIENT=ON \
-DENABLE_UDEV=ON \
-DENABLE_UPNP=ON \
-DENABLE_VAAPI=ON \
-DENABLE_VDPAU=ON \
-DENABLE_XSLT=ON \
-DDATE_URL=${DATE_URL} \
-DLIBDVDREAD_URL=$(DVDREAD_URL) \
-DLIBDVDNAV_URL=$(DVDNAV_URL) \
-DENABLE_LIRCCLIENT=ON \
-DNEON=False \
-DCORE_PLATFORM_NAME="$(KODI_PLATFORMS)" \
-DAPP_RENDER_SYSTEM=gl \
$(EXTRA_FLAGS)

%:
	dh $@ --buildsystem cmake --with python3

override_dh_clean:
	dh_clean \
		addons/skin.estuary/media/from-debian-logo.png \
		addons/webinterface.default/ \
		debian/dh-addon/*.1 \
		kodi_build_*/ \
		lib/gtest/ \
		media/Fonts/arial.ttf \
		native-tools/ \
		tools/depends/native/JsonSchemaBuilder/native/ \
		tools/depends/native/JsonSchemaBuilder/.installed-native \
		tools/depends/native/TexturePacker/native/ \
		tools/depends/native/TexturePacker/.installed-native

# fall back to old location of DejaVuSans.ttf if needed
ifneq ("$(wildcard /usr/share/fonts/truetype/dejavu/DejaVuSans.ttf)","")
DEJAVUSANS=/usr/share/fonts/truetype/dejavu/DejaVuSans.ttf
else
DEJAVUSANS=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf
endif

media/Fonts/arial.ttf: debian/mergefonts.ff
	# work around #948876 until fontforge is fixed by using cached result
	fontforge -script $< \
		/usr/share/fonts/truetype/droid/DroidSansFallbackFull.ttf \
		$(DEJAVUSANS) \
		$@ || cp debian/extra/arial.ttf $@

lib/gtest/lib/.libs/libgtest.a:
	cp -r /usr/src/gtest/ $(CURDIR)/lib/ && mkdir -p $(CURDIR)/lib/gtest/lib/.libs

addons/skin.estuary/media/from-debian-logo.png: debian/from-debian-logo.svg
	rsvg-convert -w 250 -h 82 -o $@ $<

override_dh_auto_configure: addons/skin.estuary/media/from-debian-logo.png lib/gtest/lib/.libs/libgtest.a media/Fonts/arial.ttf
	cp -r $(CURDIR)/debian/webinterface-default $(CURDIR)/addons/webinterface.default
	sed -i 's/DEB_VERSION/"'$(DEB_VERSION)'"/' xbmc/Application.cpp xbmc/utils/SystemInfo.cpp
	tar -cf $(DATE_URL) $(DATE_COMPONENT)
	tar -cf $(DVDNAV_URL) $(DVDNAV_COMPONENT)
	tar -cf $(DVDREAD_URL) $(DVDREAD_COMPONENT)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	# We are cross-compiling!
	# Produce the JsonSchemaBuilder and TexturePacker
	# prerequisites for the build architecture
	cd tools/depends/native/JsonSchemaBuilder && \
		make NATIVEPREFIX=$(CURDIR)/native-tools
	cd tools/depends/native/TexturePacker && \
		make NATIVEPREFIX=$(CURDIR)/native-tools
endif
	dh_auto_configure -- $(KODI_OPTS)

override_dh_auto_build:
	dh_auto_build
	for file in $$(ls debian/dh-addon/dh_*); do \
		pod2man --section=1 --utf8 $$file $$file.1; \
	done

override_dh_auto_test-arch:
	dh_auto_build -- kodi-test
	dh_auto_test -a

# No tests for indep build.
override_dh_auto_test-indep:

override_dh_install-indep:
	# Perform arch-independent install
	dh_install -i -XLICENCE -XLICENSE \
		-XLicence.txt -XLicense.txt -XLICENSE.txt \
		-XNOTICE.txt \
		-Xjquery-1.8.2.min.js -Xiscroll-min.js
	# Remove kodi-repository-kodi part from kodi-data
	rm -rf debian/kodi-data/usr/share/kodi/addons/repository.xbmc.org
	# Remove documentation-outside-usr-share-doc but not from addons
	rm -f debian/kodi-data/usr/share/kodi/privacy-policy.txt
	# Install kodi-repository-kodi
	dh_install -pkodi-repository-kodi \
		addons/repository.xbmc.org/* usr/share/kodi/addons/repository.xbmc.org
	# ship xbmcclient.h only in kodi-eventclients-dev
	rm -f debian/kodi-addons-dev-common/usr/include/kodi/xbmcclient.h
	# check if all needed headers are included
	$(CXX) -E -c debian/headers-check.c -DBUILD_KODI_ADDON \
	$(shell dpkg-buildflags --get CPPFLAGS) \
	$(shell dpkg-buildflags --get CXXFLAGS) \
	-Idebian/kodi-addons-dev-common/usr/include \
	-o /dev/null

override_dh_install-arch:
	# Prepare kodi-eventclients-dev dummy file
	# see debian/control for explanation of package purpose
	touch debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/kodi/eventclients-dev
	# Rename zeroconf.py to zeroconf and move to multi-arch location
	mv debian/tmp/usr/lib/python*/*/kodi/zeroconf.py debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/kodi/zeroconf
	# Perform arch-specific install
	dh_install -a -XLICENCE -XLICENSE -XLicence.txt -XLicense.txt -XLICENSE.txt -XNOTICE.txt
	# Drop executable flag from all Python scripts except:
	# ps3_remote.py
	# sixpair.py
	# sixwatch.py
	find debian/kodi-eventclients-*/ \
		! \( -name "ps3_remote.py" -o -name "sixpair.py" -o -name "sixwatch.py" \) \
		-name "*.py" -exec chmod 0644 '{}' \;

=== debian/watch ===
version=4

# Alpha bare git branch
#
# Since v20, bare git snapshots must follow the tagged release cycle:
#
#      pretty=20.0~alphaX+git%cd.%h, \
#      pretty=20.0~betaX+git%cd.%h, \
#      pretty=20.0~rcX+git%cd.%h, \
#
# where X starts with zero. The 'pretty' attribute must be changed manually
# after the correspondent tagged release is published.
#
#opts="mode=git, \
#      pgpmode=none, \
#      pretty=20.0~alpha0+git%cd.%h, \
#      repack, \
#      repacksuffix=+dfsg1, \
#      compression=xz, \
#      uversionmangle=s/\([\.0-9a-zA-Z]\)-.*$/\1/;s/rc/~rc/;s/a/~alpha/;s/b/~beta/;s/RC/~rc/;s/A/~alpha/;s/B/~beta/, \
#      dversionmangle=auto" \
#https://github.com/xbmc/xbmc \
#HEAD debian

# Tagged releases
# TODO: Change Kodi codename in tarball URL before packaging next Kodi major release
#
opts="repack, \
      compression=xz, \
      repacksuffix=+dfsg1,\
      uversionmangle=s/\([\.0-9a-zA-Z]\)-.*$/\1/;s/rc/~rc/;s/a/~alpha/;s/b/~beta/;s/RC/~rc/;s/A/~alpha/;s/B/~beta/, \
      dversionmangle=auto" \
https://github.com/xbmc/xbmc/releases .*archive/refs/tags/?(\d\S*)-Matrix\.tar\.gz

# date

opts="component=libdate-tz-embedded, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/HowardHinnant/date/tags .*archive/refs/tags/v?(\d\S*)\.tar\.gz \
ignore

# libdvdread

opts="component=libdvdread-embedded, \
      repack, \
      compression=xz, \
      pgpsigurlmangle=s/$/.asc/" \
https://download.videolan.org/pub/videolan/libdvdread/([\d][\d\.]+[a-z]?)/libdvdread-([\d][\d\.]+[a-z]?)\.tar\.(?:gz|bz2|xz) \
ignore

# libdvdnav

opts="component=libdvdnav-embedded, \
      repack, \
      compression=xz, \
      pgpsigurlmangle=s/$/.asc/" \
https://download.videolan.org/pub/videolan/libdvdnav/([\d][\d\.]+[a-z]?)/libdvdnav-([\d][\d\.]+[a-z]?)\.tar\.(?:gz|bz2|xz) \
ignore
